<!--
  -    Copyright [2023] Feather development team, see AUTHORS.md
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<script lang="ts" setup>
import { ref, onMounted, Ref, computed } from 'vue';
import * as api from '../../api';

const headers = [
  {
    text: 'Name',
    value: 'name',
  },
  {
    text: 'Grund',
    value: 'reasons',
    filterable: false,
    sortable: false,
  },
];
const select: Ref<string[]> = ref([]);
const selectItems: Ref<string[]> = ref([]);
const search = ref('');
const loading = ref(true);
const openActions: Ref<api.actions.ActionsByUsersResponse[]> = ref([]);
const users: Ref<api.users.UserResponse[]> = ref([]);

onMounted(() => {
  const getOpenActions = api.actions.getAllOpenActions().then((it) => {
    openActions.value = it;
    select.value = openActions.value
      .map((it) => it.actions)
      .flat()
      .map((it) => it.name)
      .filter((value, index, array) => array.indexOf(value) === index);
    selectItems.value = select.value;
  });

  const getAllUsers = api.users.getAllUsers().then((it) => {
    users.value = it;
  });

  api.allCatching([getOpenActions, getAllUsers]).finally(() => (loading.value = false));
});

function notEmpty<TValue>(value: TValue | null | undefined): value is TValue {
  return value !== null && value !== undefined;
}

const tableData = computed(() =>
  openActions.value
    .map((it) => {
      const user = users.value.filter((u) => u.id == it.userId);
      if (user.length != 1) return undefined;
      return {
        name: user[0].displayName,
        reasons: it.actions,
      };
    })
    .filter(notEmpty)
    .filter((it) => it.reasons.some((it) => select.value.some((s) => s == it.name)))
    .sort((a, b) => {
      if (a.name < b.name) {
        return -1;
      }
      if (a.name > b.name) {
        return 1;
      }
      return 0;
    })
);

const stats = computed(() => {
  const resultMap = new Map<string, number>();

  openActions.value
    .map((it) => it.actions)
    .flat()
    .forEach((it) => {
      const oldValue = resultMap.get(it.name) ?? 0;
      resultMap.set(it.name, oldValue + 1);
    });

  const result: { type: string; count: number }[] = [];

  resultMap.forEach((value, key) => {
    result.push({
      type: key,
      count: value,
    });
  });

  return result;
});
</script>

<template>
  <v-row>
    <v-col cols="12" md="12">
      <v-card>
        <v-card-title>
          Geblockte Benutzer:innen
          <v-spacer></v-spacer>
          <v-text-field
            v-model="search"
            append-icon="mdi-magnify"
            label="Suche"
            single-line
            hide-details
            :disabled="selectItems.length == 0"
          ></v-text-field>
        </v-card-title>
        <v-card-subtitle>
          <ul v-for="action in stats">
            <li>{{ action.type }}: {{ action.count }}</li>
          </ul>
        </v-card-subtitle>

        <v-card-text>
          <v-autocomplete
            v-model="select"
            :items="selectItems"
            dense
            chips
            small-chips
            label="Filtern nach Grund"
            multiple
            solo
            deletable-chips
            :disabled="selectItems.length == 0"
          ></v-autocomplete>

          <v-data-table :headers="headers" :items="tableData" :search="search" :loading="loading">
            <template v-slot:item.reasons="{ item }">
              <ul v-for="reason in item.reasons">
                <li>{{ reason.name }} ({{ reason.description }})</li>
              </ul>
            </template>
          </v-data-table>
        </v-card-text>
      </v-card>
    </v-col>
  </v-row>
</template>
